# See at https://docs.gitlab.com/runner/install/docker.html#option-1-use-local-system-volume-mounts-to-start-the-runner-container
- name: Install pip
  ansible.builtin.apt:
    name:
      - python3-pip

- name: Install python docker for docker
  ansible.builtin.pip:
    name:
      - docker

- name: Run gitlab-runner in docker
  vars:
    container_name: gitlab-runner
    runner_config_dir: /srv/gitlab-runner/config
    runner_config_path: "{{ runner_config_dir }}/config.toml"
  block:
    - name: Get container info
      community.docker.docker_container_info:
        name: "{{ container_name }}"
      register: container_info

    - name: Run gitlab-runner in docker
      community.docker.docker_container:
        image: gitlab/gitlab-runner:latest
        name: "{{ container_name }}"
        detach: yes
        restart_policy: always
        volumes:
          - /srv/gitlab-runner/config:/etc/gitlab-runner
          - /var/run/docker.sock:/var/run/docker.sock
      when: not container_info.exists

    - name: Get runner config stats
      stat:
        path: "{{ runner_config_path }}"
      register: runner_config_file

    - name: Copy runner config
      copy:
        src: ./conf/gitlab-runner-config.toml
        dest: "{{ runner_config_path }}"
      when: not runner_config_file.stat.exists